<?php
/**
 * Electrical Services functions and definitions
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package electrical_services
 */

if ( ! defined( 'ELECTRICAL_SERVICES_VERSION' ) ) {
	define( 'ELECTRICAL_SERVICES_VERSION', '1.0' );
}

$electrical_services_theme_data = wp_get_theme();

if( ! defined( 'ELECTRICAL_SERVICES_THEME_VERSION' ) ) define ( 'ELECTRICAL_SERVICES_THEME_VERSION', $electrical_services_theme_data->get( 'Version' ) );
if( ! defined( 'ELECTRICAL_SERVICES_THEME_NAME' ) ) define( 'ELECTRICAL_SERVICES_THEME_NAME', $electrical_services_theme_data->get( 'Name' ) );

if ( ! function_exists( 'electrical_services_setup' ) ) :
	
	function electrical_services_setup() {
		
		load_theme_textdomain( 'electrical-services', get_template_directory() . '/languages' );

		add_theme_support( 'woocommerce' );

		add_theme_support( 'automatic-feed-links' );
		
		add_theme_support( 'title-tag' );

		add_theme_support( 'post-thumbnails' );

		register_nav_menus(
			array(
				'primary' => esc_html__( 'Primary', 'electrical-services' ),
			)
		);

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'style',
				'script',
				'woocommerce',
			)
		);

		add_theme_support( 'post-formats', array(
			'image',
			'video',
			'gallery',
			'audio', 
		) );

		add_theme_support(
			'custom-background',
			apply_filters(
				'electrical_services_custom_background_args',
				array(
					'default-color' => 'ffffff',
					'default-image' => '',
				)
			)
		);

		add_theme_support( 'customize-selective-refresh-widgets' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 250,
				'width'       => 250,
				'flex-width'  => true,
				'flex-height' => true,
			)
		);

		add_theme_support( 'align-wide' );

		add_theme_support( 'responsive-embeds' );

		/*  Demo Import */
		require get_parent_theme_file_path( '/theme-wizard/config.php' );

		/*
		* This theme styles the visual editor to resemble the theme style,
		* specifically font, colors, icons, and column width.
		*/
		add_editor_style( '/resource/css/editor-style.css' );

	}
endif;
add_action( 'after_setup_theme', 'electrical_services_setup' );

function electrical_services_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'electrical_services_content_width', 640 );
}
add_action( 'after_setup_theme', 'electrical_services_content_width', 0 );

function electrical_services_widgets_init() {
	register_sidebar(
		array(
			'name'          => esc_html__( 'Sidebar', 'electrical-services' ),
			'id'            => 'sidebar-1',
			'description'   => esc_html__( 'Add widgets here.', 'electrical-services' ),
			'before_widget' => '<section id="%1$s" class="widget %2$s">',
			'after_widget'  => '</section>',
			'before_title'  => '<h2 class="widget-title"><span>',
			'after_title'   => '</span></h2>',
		)
	);

	// Regsiter 4 footer widgets.
	$electrical_services_footer_widget_column = get_theme_mod('electrical_services_footer_widget_column','4');
	for ($electrical_services_i=1; $electrical_services_i<=$electrical_services_footer_widget_column; $electrical_services_i++) {
		register_sidebar( array(
			'name' => __( 'Footer  ', 'electrical-services' )  . $electrical_services_i,
			'id' => 'footer-widget-' . $electrical_services_i,
			'description' => __( 'The Footer Widget Area', 'electrical-services' )  . $electrical_services_i,
			'before_widget' => '<aside id="%1$s" class="widget %2$s">',
			'after_widget' => '</aside>',
			'before_title' => '<div class="widget-header"><h4 class="widget-title">',
			'after_title' => '</h4></div>',
		) );
	}
}
add_action( 'widgets_init', 'electrical_services_widgets_init' );

/**
 * Enqueue scripts and styles.
 */
function electrical_services_scripts() {
	// Append .min if SCRIPT_DEBUG is false.
	$min = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';

	// Fontawesome style.
	wp_enqueue_style( 'font-awesome-css', esc_url(get_template_directory_uri())."/resource/css/fontawesome-all.css" );

	// Main style.
	wp_enqueue_style( 'electrical-services-style', get_template_directory_uri() . '/style.css', array(), ELECTRICAL_SERVICES_VERSION );

	// Isolated banner styles loaded after main stylesheet.
	wp_enqueue_style( 'electrical-services-banner-section-style', get_template_directory_uri() . '/resource/css/banner-section-custom.css', array( 'electrical-services-style' ), ELECTRICAL_SERVICES_VERSION );

	// Isolated services section styles.
	wp_enqueue_style( 'electrical-services-services-section-style', get_template_directory_uri() . '/resource/css/services-section-custom.css', array( 'electrical-services-style' ), ELECTRICAL_SERVICES_VERSION );

	// RTL style.
	wp_style_add_data('electrical-services-style', 'rtl', 'replace');

	if (get_theme_mod('electrical_services_enable_animation', true) == true){
		// Animate CSS
		wp_enqueue_style( 'animate-style', get_template_directory_uri() . '/resource/css/animate.css' );
		// Wow script.
		wp_enqueue_script( 'wow-jquery', get_template_directory_uri() . '/resource/js/wow.js', array('jquery'),'' ,true );
	}

	wp_enqueue_style( 'owl.carousel-css', esc_url(get_template_directory_uri())."/resource/css/owl.carousel.css" );

	// Navigation script.
	wp_enqueue_script( 'electrical-services-navigation-script', get_template_directory_uri() . '/resource/js/navigation.js', array(), ELECTRICAL_SERVICES_VERSION, true );

	wp_enqueue_script( 'owl.carousel-js', esc_url(get_template_directory_uri()) . '/resource/js/owl.carousel.js', array( 'jquery' ), ELECTRICAL_SERVICES_VERSION, true );

	// Custom script.
	wp_enqueue_script( 'electrical-services-custom-script', get_template_directory_uri() . '/resource/js/custom.js', array( 'jquery', 'owl.carousel-js' ), ELECTRICAL_SERVICES_VERSION, true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	// Include the file.
	require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

	// Load the Roboto Flex webfont.
	wp_enqueue_style(
		'Roboto Flex',
		Electrical_Services_wptt_get_webfont_url(
			'https://fonts.googleapis.com/css2?family=Roboto+Flex:wdth,wght@25..151,100..1000&display=swap'
		),
		array(),
		'1.0'
	);

	// Load the Familjen Grotesk webfont.
	wp_enqueue_style(
		'Familjen Grotesk',
		Electrical_Services_wptt_get_webfont_url(
			'https://fonts.googleapis.com/css2?family=Familjen+Grotesk:wght@400..700&display=swap'
		),
		array(),
		'1.0'
	);
}
add_action( 'wp_enqueue_scripts', 'electrical_services_scripts' );

//Change number of products per page 
add_filter( 'loop_shop_per_page', 'electrical_services_products_per_page' );
function electrical_services_products_per_page( $cols ) {
  	return  get_theme_mod( 'electrical_services_products_per_page',9);
}

// Change number or products per row 
add_filter('loop_shop_columns', 'electrical_services_loop_columns');
	if (!function_exists('electrical_services_loop_columns')) {
	function electrical_services_loop_columns() {
		return get_theme_mod( 'electrical_services_products_per_row', 3 );
	}
}

/**
 * Include wptt webfont loader.
 */
require_once get_theme_file_path( 'theme-library/function-files/wptt-webfont-loader.php' );

/**
 * Implement the Custom Header feature.
 */
require get_template_directory() . '/theme-library/custom-header.php';

/**
 * Custom template tags for this theme.
 */
require get_template_directory() . '/theme-library/function-files/template-tags.php';

/**
 * Functions which enhance the theme by hooking into WordPress.
 */
require get_template_directory() . '/theme-library/function-files/template-functions.php';

/**
 * Customizer additions.
 */
require get_template_directory() . '/theme-library/customizer.php';

/**
 * Google Fonts
 */
require get_template_directory() . '/theme-library/function-files/google-fonts.php';

/**
 * Dynamic CSS
 */
require get_template_directory() . '/theme-library/dynamic-css.php';

/**
 * Breadcrumb
 */
require get_template_directory() . '/theme-library/function-files/class-breadcrumb-trail.php';

/**
 * Customizer Settings Functions
*/
require get_template_directory() . '/theme-library/function-files/customizer-settings-functions.php';
/**
 * Getting Started
*/
require get_template_directory() . '/theme-library/getting-started/getting-started.php';

function electrical_services_links_setup() {
	if ( ! defined( 'ELECTRICAL_SERVICES_PREMIUM_PAGE' ) ) {
	define('ELECTRICAL_SERVICES_PREMIUM_PAGE',__('https://asterthemes.com/products/electrician-wordpress-theme','electrical-services'));
	}
	if ( ! defined( 'ELECTRICAL_SERVICES_THEME_PAGE' ) ) {
		define('ELECTRICAL_SERVICES_THEME_PAGE',__('https://asterthemes.com/products/electrical-services','electrical-services'));
	}
	if ( ! defined( 'ELECTRICAL_SERVICES_SUPPORT' ) ) {
	define('ELECTRICAL_SERVICES_SUPPORT',__('https://wordpress.org/support/theme/electrical-services/','electrical-services'));
	}
	if ( ! defined( 'ELECTRICAL_SERVICES_REVIEW' ) ) {
	define('ELECTRICAL_SERVICES_REVIEW',__('https://wordpress.org/support/theme/electrical-services/reviews/','electrical-services'));
	}
	if ( ! defined( 'ELECTRICAL_SERVICES_PRO_DEMO' ) ) {
	define('ELECTRICAL_SERVICES_PRO_DEMO',__('https://demo.asterthemes.com/electrical-services/','electrical-services'));
	}
	if ( ! defined( 'ELECTRICAL_SERVICES_THEME_DOCUMENTATION' ) ) {
	define('ELECTRICAL_SERVICES_THEME_DOCUMENTATION',__('https://demo.asterthemes.com/docs/electrical-services-free/','electrical-services'));
	}
	if ( ! defined( 'ELECTRICAL_SERVICES_PREMIUM_DOCUMENTATION' ) ) {
	define('ELECTRICAL_SERVICES_PREMIUM_DOCUMENTATION',__('https://demo.asterthemes.com/docs/electrical-services-pro/','electrical-services'));
	}
	if ( ! defined( 'ELECTRICAL_SERVICES_BUNDLE_PAGE' ) ) {
		define('ELECTRICAL_SERVICES_BUNDLE_PAGE',__('https://asterthemes.com/products/wp-theme-bundle','electrical-services'));
	}
}
add_action('after_setup_theme', 'electrical_services_links_setup');

// Enqueue Customizer live preview script
function electrical_services_customizer_live_preview() {
    wp_enqueue_script(
        'electrical-services-customizer',
        get_template_directory_uri() . '/resource/js/customizer.js',
        array('jquery', 'customize-preview'),
        '',
        true
    );
}
add_action('customize_preview_init', 'electrical_services_customizer_live_preview');

// Featured Image Dimension
function electrical_services_blog_post_featured_image_dimension(){
	if(get_theme_mod('electrical_services_blog_post_featured_image_dimension') == 'custom' ) {
		return true;
	}
	return false;
}
add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

// Reset all theme settings
function electrical_services_reset_demo_import_settings() {
    if (current_user_can('manage_options')) {
        // List only demo import-related settings to reset
		remove_theme_mod('electrical_services_enable_topbar');
		remove_theme_mod('electrical_services_location_view_button_text');
		remove_theme_mod('electrical_services_location_view_button_url');
		remove_theme_mod('electrical_services_order_view_button_text');
		remove_theme_mod('electrical_services_order_view_button_url');
		remove_theme_mod('electrical_services_enable_header_search_section');
		remove_theme_mod('electrical_services_enable_banner_section');
		remove_theme_mod('electrical_services_banner_section_heading');
		remove_theme_mod('electrical_services_banner_section_sub_heading');
		remove_theme_mod('electrical_services_banner_section_content');
		remove_theme_mod('electrical_services_banner_button_label_one');
		remove_theme_mod('electrical_services_banner_button_link_one');
		remove_theme_mod('electrical_services_banner_button_label_two');
		remove_theme_mod('electrical_services_banner_button_link_two');
		remove_theme_mod('electrical_services_banner_right_title');
		remove_theme_mod('electrical_services_banner_image_title');
		remove_theme_mod('electrical_services_enable_product_section');
		remove_theme_mod('electrical_services_trending_product_heading');
		remove_theme_mod('electrical_services_product_view_button_text');
		remove_theme_mod('electrical_services_product_view_button_url');

        wp_send_json_success(array('message' => __('Demo import settings have been reset.', 'electrical-services')));
    } else {
        wp_send_json_error(array('message' => __('Permission denied.', 'electrical-services')));
    }
}
add_action('wp_ajax_electrical_services_reset_demo_import_settings', 'electrical_services_reset_demo_import_settings'); 